/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _VIRTUAL_PLAYLIST_H_
#define _VIRTUAL_PLAYLIST_H_

#include <QObject>
#include <QStringList>
#include <QList>
#include <QString>

#include "MediaItem/mediaitem.h"

/*
********************************************************************************
*                                                                              *
*    Class VirtualPlayqueue                                                    *
*                                                                              *
********************************************************************************
*/   
class VirtualPlayqueue : public QObject
{
Q_OBJECT
  public: 
    VirtualPlayqueue(QWidget *parent=0);
    
    void appendMedia(const MediaItemPtr media);
    void appendMedias(QList<MediaItemPtr> list, int startIdx);

    void clear();
    
    MediaItemPtr getActiveMediaItem();
    MediaItemPtr getNextMediaItem();
    MediaItemPtr getPrevMediaItem();

    QString getActiveTrack();
    QString getNextTrack();
    QString getPrevTrack();  
    
    void    stopPlaying();
    bool    isPlaying() {return _isPlaying;}

  private :
    void setActiveMedia(int idx);
    QList<MediaItemPtr> unplayedMedia();

  private :
    enum RepeatMode {RepeatOff = 0,RepeatTrack = 1, RepeatAll = 2 };
    enum ShuffleMode {ShuffleOff = 0 ,ShuffleOn = 1};

    QList<MediaItemPtr>       _listMedia;
    bool                      _isPlaying; 
    int                       _playingIdx;

  signals :
    void signal_collection_playTrack();
};

#endif // _VIRTUAL_PLAYLIST_H_






